namespace Upsilon.BaseTypes
{
    internal class ScriptBoolean : ScriptType
    {
        public ScriptBoolean(bool value)
        {
            Value = value;
        }

        public override Type Type => Type.Boolean;
        public override object ToCSharpObject()
        {
            return Value;
        }

        public override System.Type GetCSharpType()
        {
            return typeof(bool);
        }

        public bool Value { get; }

        public static implicit operator bool(ScriptBoolean b)
        {
            return b.Value;
        }

        public static implicit operator ScriptBoolean(bool b)
        {
            return new ScriptBoolean(b);
        }

        public static ScriptBoolean operator ! (ScriptBoolean n)
        {
            return new ScriptBoolean(!n.Value);
        }

        public override string ToString()
        {
            return Value.ToString();
        }
    }
}