using System.Collections.Generic;

namespace Upsilon.BaseTypes.UserData
{
    public static class UserDataTypeHandler
    {
        private static readonly Dictionary<System.Type, UserDataType> _types = new Dictionary<System.Type, UserDataType>();

        public static void LoadType(System.Type t)
        {
            var info = new UserDataType(t);
            _types.Add(t, info);
        }

        public static void LoadType<T>()
        {
            LoadType(typeof(T));
        }

        internal static UserDataType GetTypeInfo(System.Type t)
        {
            return _types[t];
        }
    }
}