using Upsilon.BaseTypes;
using Upsilon.Text;

namespace Upsilon.Binder
{
    public class BoundBinaryExpression : BoundExpression
    {
        public BoundBinaryExpression(BoundBinaryOperator op, BoundExpression leftExpression,
            BoundExpression rightExpression, Type type, TextSpan span) : base(span)
        {
            Operator = op;
            LeftExpression = leftExpression;
            RightExpression = rightExpression;
            Type = type;
        }

        public override BoundKind Kind => BoundKind.BoundBinaryExpression;
        public override BoundNode GetNodeAtPosition(int characterPosition)
        {
            if (characterPosition >= LeftExpression.Span.Start && characterPosition <= LeftExpression.Span.End)
                return LeftExpression.GetNodeAtPosition(characterPosition);
            if (characterPosition >= RightExpression.Span.Start && characterPosition <= RightExpression.Span.End)
                return RightExpression.GetNodeAtPosition(characterPosition);
            return this;

        }

        public override Type Type { get; }

        public BoundBinaryOperator Operator { get; }
        public BoundExpression LeftExpression { get; }
        public BoundExpression RightExpression { get; }
    }
}