using Upsilon.BaseTypes;
using Upsilon.Text;

namespace Upsilon.Binder
{
    internal class BoundLiteralExpression : BoundExpression
    {
        public BoundLiteralExpression(ScriptType value, TextSpan span) : base(span)
        {
            Value = value;
        }

        public override BoundKind Kind => BoundKind.BoundLiteralExpression;
        public override BoundNode GetNodeAtPosition(int characterPosition)
        {
            return this;
        }

        public override Type Type => Value.Type;
        public ScriptType Value { get; }
    }
}