using System;
using Upsilon.Text;
using Type = Upsilon.BaseTypes.Type;

namespace Upsilon.Binder
{
    public class BoundVariableExpression : BoundExpression
    {
        public BoundVariableExpression(BoundVariableSymbol variable, TextSpan span) : base(span)
        {
            Variable = variable;
        }

        public BoundVariableSymbol Variable { get; }
        public override BoundKind Kind => BoundKind.VariableExpression;
        public override BoundNode GetNodeAtPosition(int characterPosition)
        {
            return Variable;
        }

        public override Type      Type => Variable.Type;
    }
}