using System.Collections.Immutable;
using System.Linq;
using Upsilon.Text;

namespace Upsilon.Binder
{
    public class BoundBlockStatement : BoundStatement
    {
        public BoundBlockStatement(ImmutableArray<BoundStatement> statements, TextSpan span) : base(span)
        {
            Statements = statements;
        }

        public override BoundKind Kind => BoundKind.BoundBlockStatement;
        public override BoundNode GetNodeAtPosition(int characterPosition)
        {
            foreach (var statement in Statements)
            {
                if (characterPosition >= statement.Span.Start && characterPosition <= statement.Span.End)
                    return statement.GetNodeAtPosition(characterPosition);
            }
            return this;
        }

        public ImmutableArray<BoundStatement> Statements { get; }
    }
}