using Upsilon.Text;

namespace Upsilon.Binder
{
    public class BoundExpressionStatement : BoundStatement
    {
        public BoundExpression Expression { get; }
        public override BoundKind Kind => BoundKind.BoundExpressionStatement;
        public override BoundNode GetNodeAtPosition(int characterPosition)
        {
            if (characterPosition >= Span.Start && characterPosition <= Span.End)
                return Expression.GetNodeAtPosition(characterPosition);
            return null;
        }

        public BoundExpressionStatement(BoundExpression expression, TextSpan span):base(span)
        {
            Expression = expression;
        }
    }
}