using Upsilon.Text;

namespace Upsilon.Binder
{
    public class BoundFunctionAssignmentStatement : BoundStatement
    {
        public VariableSymbol          Variable { get; }
        public BoundFunctionExpression Func     { get; }

        public BoundFunctionAssignmentStatement(VariableSymbol variable, BoundFunctionExpression func, TextSpan span): base(span)
        {
            Variable = variable;
            Func     = func;
        }

        public override BoundKind Kind => BoundKind.BoundFunctionAssignmentStatement;
        public override BoundNode GetNodeAtPosition(int characterPosition)
        {
            if (characterPosition >= Func.Span.Start && characterPosition <= Func.Span.End)
                return Func.GetNodeAtPosition(characterPosition);
            return this;
        }
    }
}