using System.Collections.Generic;
using System.Collections.Immutable;
using Upsilon.Text;

namespace Upsilon.Binder
{
    public class BoundMultiAssignmentStatement : BoundStatement
    {
        public ImmutableArray<VariableSymbol> Variables { get; }
        public BoundExpression Assignment { get; }

        public BoundMultiAssignmentStatement(ImmutableArray<VariableSymbol> variables, BoundExpression assignment,
            TextSpan span) : base(span)
        {
            Variables = variables;
            Assignment = assignment;
        }

        public override BoundKind Kind => BoundKind.BoundMultiAssignmentStatement;
        public override BoundNode GetNodeAtPosition(int characterPosition)
        {
            if (characterPosition >= Assignment.Span.Start && characterPosition <= Assignment.Span.End)
                return Assignment.GetNodeAtPosition(characterPosition);
            return this;

        }
    }
}