using Upsilon.Text;

namespace Upsilon.Binder
{
    public class BoundNumericForStatement : BoundStatement
    {
        public VariableSymbol Variable { get; }
        public BoundExpression BoundStart { get; }
        public BoundExpression BoundStop { get; }
        public BoundExpression BoundStep { get; }
        public BoundBlockStatement Block { get; }

        public BoundNumericForStatement(VariableSymbol variable, BoundExpression boundStart,
            BoundExpression boundStop, BoundExpression boundStep, BoundBlockStatement block, TextSpan span) : base(span)
        {
            Variable = variable;
            BoundStart = boundStart;
            BoundStop = boundStop;
            BoundStep = boundStep;
            Block = block;
        }

        public override BoundKind Kind => BoundKind.BoundNumericForStatement;
        public override BoundNode GetNodeAtPosition(int characterPosition)
        {
            if (characterPosition >= BoundStart.Span.Start && characterPosition <= BoundStart.Span.End)
                return BoundStart.GetNodeAtPosition(characterPosition);
            if (characterPosition >= BoundStop.Span.Start && characterPosition <= BoundStop.Span.End)
                return BoundStop.GetNodeAtPosition(characterPosition);
            if (characterPosition >= BoundStep.Span.Start && characterPosition <= BoundStep.Span.End)
                return BoundStep.GetNodeAtPosition(characterPosition);
            if (characterPosition >= Block.Span.Start && characterPosition <= Block.Span.End)
                return Block.GetNodeAtPosition(characterPosition);
            return this;

        }
    }
}