using Upsilon.Text;

namespace Upsilon.Binder
{
    public class BoundReturnStatement : BoundStatement
    {
        public BoundReturnStatement(BoundExpression expression, TextSpan span) : base(span)
        {
            Expression = expression;
        }

        public BoundExpression Expression { get; }
        public override BoundKind Kind => BoundKind.BoundReturnStatement;
        public override BoundNode GetNodeAtPosition(int characterPosition)
        {
            if (characterPosition >= Expression.Span.Start && characterPosition <= Expression.Span.End)
                return Expression.GetNodeAtPosition(characterPosition);
            return this;
        }
    }
}