using Upsilon.Text;

namespace Upsilon.Binder
{
    public class BoundTableAssigmentStatement : BoundStatement
    {
        public BoundExpression TableIndexExpression { get; }
        public BoundExpression Value { get; }

        public BoundTableAssigmentStatement(BoundExpression tableIndexExpression, BoundExpression value,
            TextSpan span) : base(span)
        {
            TableIndexExpression = tableIndexExpression;
            Value = value;
        }

        public override BoundKind Kind => BoundKind.BoundTableAssigmentStatement;
        public override BoundNode GetNodeAtPosition(int characterPosition)
        {
            if (characterPosition >= TableIndexExpression.Span.Start && characterPosition <= TableIndexExpression.Span.End)
                return TableIndexExpression.GetNodeAtPosition(characterPosition);
            if (characterPosition >= Value.Span.Start && characterPosition <= Value.Span.End)
                return Value.GetNodeAtPosition(characterPosition);
            return this;

        }
    }
}