using System.Collections.Immutable;
using Upsilon.Parser;
using Upsilon.Text;

namespace Upsilon.Binder
{
    public class UnboundFunctionExpression : BoundFunctionExpression
    {
        public UnboundFunctionExpression(ImmutableArray<BoundVariableSymbol> parameters,
            BlockStatementSyntax unboundBlock, TextSpan span) : base(parameters, null, span)
        {
            UnboundBlock = unboundBlock;
        }

        public override BoundKind Kind => BoundKind.BoundPromise;

        public BlockStatementSyntax UnboundBlock { get; }

        public override BoundNode GetNodeAtPosition(int characterPosition)
        {
            foreach (var parameter in Parameters)
            {
                if (characterPosition >= parameter.Span.Start && characterPosition <= parameter.Span.End)
                    return parameter.GetNodeAtPosition(characterPosition);
            }

            if (Block != null)
            {
                if (characterPosition >= Block.Span.Start && characterPosition <= Block.Span.End)
                    return Block.GetNodeAtPosition(characterPosition);

            }
            return this;
        }
    }
}