using System.Collections.Generic;
using Upsilon.Text;

namespace Upsilon.Parser
{
    public class ReturnStatementSyntax : StatementSyntax
    {
        public ReturnStatementSyntax(SyntaxToken returnToken, ExpressionSyntax expression)
        {
            ReturnToken = returnToken;
            Expression = expression;
            Span = new TextSpan(returnToken.Span.Start, expression.Span.End - returnToken.Span.Start);
        }

        public SyntaxToken ReturnToken { get; }
        public ExpressionSyntax Expression { get; }
        public override SyntaxKind Kind => SyntaxKind.ReturnStatement;
        public override IEnumerable<SyntaxNode> ChildNodes()
        {
            yield return Expression;
        }
    }
}