using System.Collections.Generic;
using System.Reflection;
using Upsilon.BaseTypes;
using Upsilon.BaseTypes.UserData;

namespace Upsilon.StandardLibraries
{
    internal abstract class LuaLibrary
    {
        public Dictionary<string, ScriptFunction> LoadMethods()
        {
            var dictionary = new Dictionary<string, ScriptFunction>();
            var methods = GetType().GetMethods();
            foreach (var methodInfo in methods)
            {
                var attr = methodInfo.GetCustomAttribute<StandardLibraryScriptFunctionAttribute>();
                if (attr != null)
                {
                    dictionary.Add(attr.Name, new ScriptMethodInfoFunction(new UserDataMethod(methodInfo), this, true));
                }
            }

            return dictionary;
        }

    }
}